import java.util.List;

import org.springframework.mock.web.MockHttpServletRequest;
import org.springframework.mock.web.MockHttpServletResponse;
import org.springframework.showcase.coverc.domain.Recipe;
import org.springframework.showcase.coverc.service.StubRecipeManager;
import org.springframework.showcase.coverc.web.SwitchBoardController;
import org.springframework.test.AbstractDependencyInjectionSpringContextTests;
import org.springframework.web.servlet.ModelAndView;



public class SampleTestCase extends AbstractDependencyInjectionSpringContextTests {
	public String[] getConfigLocations() {
		return new String[] {
				"WEB-INF/applicationContext.xml",
				"WEB-INF/coverc-servlet.xml"
		};
	}
	
	public void testFindById() {
		StubRecipeManager manager = new StubRecipeManager();
		
		Recipe recipe = manager.findById(1L);
		assertNotNull(recipe);
		assertEquals("Goats Cheese with beetroot sauce", recipe.getName());
	}
	
	public void testIntegrated() throws Exception {
		MockHttpServletRequest req = new MockHttpServletRequest("POST","switchBoadController/listRecipes.htm");
		
		SwitchBoardController	controller = (SwitchBoardController)getApplicationContext().getBean("switchBoadController");
		
		ModelAndView mv = controller.handleRequest(req,new MockHttpServletResponse());

		assertNull(mv.getViewName());
		List list = (List)mv.getModel().get("recipeList");
		assertEquals(3, list.size());
		Recipe recipe = (Recipe)list.get(0);
		assertEquals("Goats Cheese with beetroot sauce", recipe.getName());
	}
}
